package com.xkrs.dao;

import com.xkrs.model.entity.StreetEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Optional;

@Component
public interface StreetDao extends JpaRepository<StreetEntity, Integer>, JpaSpecificationExecutor<StreetEntity> {

    List<StreetEntity> findByProName(String proName);

    List<StreetEntity> findByProCode(String proCode);

    List<StreetEntity> findByCityName(String cityName);

    List<StreetEntity> findByCityCode(String cityCode);

    List<StreetEntity> findByCountyName(String countyName);

    List<StreetEntity> findByCountyCode(String countyCode);

    Optional<StreetEntity> findByStreetName(String streetName);

    Optional<StreetEntity> findByStreetCode(String streetCode);

}
